EDIT - bug #6300

DatalntegrityViolationException when saving a type
12/22/2016 04:07 PM - Patrick Plitzner

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 4.6

Severity: normal Found in Version: Release 4.4
Description

Walter:

"Hallo,

habe eine Typusangabe in den Cache gestellt, beim Speichern des Taxons dann untenstehender Fehler.
Herzlichen Gruf3

Walter"

Saving a type designation

login : wgb

editor version : 4.4.1

server : api.cybertaxonomy.org / cybertaxonomy.org

schema version : 4.1.0.0.201607300000

os : Windows 10 10.0 amdé64

java : 1.8.0_111

org.springframework.dao.DataIntegrityViolationException: could not execute statement; SQL [n/al; c
onstraint [UK_b8inp8ckel89cpod7euwnObgf]; nested exception is org.hibernate.exception.ConstraintVi

olationException: could not execute statement

at org.springframework.orm.hibernate5.SessionFactoryUtils.convertHibernateAccessEx
ception (SessionFactoryUtils. java:164)

at org.springframework.orm.hibernate5.HibernateTransactionManager.convertHibernate
AccessException (HibernateTransactionManager. java:741)

at org.springframework.orm.hibernate5.HibernateTransactionManager.doCommit (Hiberna
teTransactionManager. java:589)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.proc
essCommit (AbstractPlatformTransactionManager. java:761)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.comm
it (AbstractPlatformTransactionManager. java:730)

at org.springframework.transaction.interceptor.TransactionAspectSupport.commitTran
sactionAfterReturning(TransactionAspectSupport. java:485)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWith
inTransaction (TransactionAspectSupport.java:291)
at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (Trans
actionInterceptor.java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective
MethodInvocation. java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.

java:208)

at com.sun.proxy.S$Proxy2832.merge (Unknown Source)

at sun.reflect.GeneratedMethodAccessor28484.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. ja
va:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtil
s.java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (Re
flectiveMethodInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective
MethodInvocation. java:157)

at org.springframework.remoting.support.RemoteInvocationTracelnterceptor.invoke (Re
moteInvocationTraceInterceptor. java:78)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective
MethodInvocation. java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.

java:208)

at com.sun.proxy.S$SProxy2916.merge (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. ja
va:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.remoting.support.RemoteInvocation.invoke (RemoteInvocation. j
ava:212)

at org.springframework.remoting.support.DefaultRemoteInvocationExecutor.invoke (Def
aultRemoteInvocationExecutor. java:39)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invoke (Remot
eInvocationBasedExporter. java:78)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invokeAndCre
ateResult (RemoteInvocationBasedExporter.java:114)

at org.springframework.remoting.httpinvoker.HttpInvokerServiceExporter.handleReque
st (HttpInvokerServiceExporter. java:74)

at org.springframework.web.servlet.mvc.HttpRequestHandlerAdapter.handle (HttpReques
tHandlerAdapter. java:51)

at org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet.
java:959)
at org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet.j
ava:893)

at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServle
t.java:969)

at org.springframework.web.servlet.FrameworkServlet.doPost (FrameworkServlet. java:8

71)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:707)

at org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet. java:
845)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder. java:808)

at org.eclipse.jetty.servlet.ServletHandler$SCachedChain.doFilter (ServletHandler. ja
va:1669)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:316)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.inv
oke (FilterSecurityInterceptor.java:126)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doF
ilter (FilterSecurityInterceptor. java:90)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy. java:330)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (Exc
eptionTranslationFilter.java:114)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.session.SessionManagementFilter.doFilter (Sessi
onManagementFilter.java:122)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.servletapi.SecurityContextHolderAwareRequestFi
lter.doFilter (SecurityContextHolderAwareRequestFilter.java:169)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.savedrequest.RequestCacheAwareFilter.doFilter (
RequestCacheAwareFilter. java:48)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy. java:330)

at org.springframework.security.web.authentication.www.BasicAuthenticationFilter.d
oFilterInternal (BasicAuthenticationFilter.java:213)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilt
er.java:107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy. java:330)
at org.springframework.

at org.eclipse. jetty.

at org.eclipse. jetty.

at org.eclipse. jetty.

at org.eclipse. jetty.

at org.eclipse. jetty.

at org.eclipse. jetty.

at org.eclipse. jetty.

web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilt

security.web.FilterChainProxy$VirtualFilterChain.doFilter (F

security.web.FilterChainProxy.doFilterInternal (FilterChainP

security.web.FilterChainProxy.doFilter (FilterChainProxy. jav
security.SecurityHandler.handle (SecurityHandler. java:577)

server.session.SessionHandler.doHandle (SessionHandler. java:22

server.handler.ContextHandler.doHandle (ContextHandler. java:11

servlet.ServletHandler.doScope (ServletHandler. java:515)
at org.eclipse.jetty.server.session.SessionHandler.doScope (SessionHandler. java:185

at org.eclipse.jetty.server.handler.ContextHandler.doScope (ContextHandler.java:106

at org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler. java:141)

at org.eclipse.jetty.server.handler.ContextHandlerCollection.handle (ContextHandler
Collection.java:215)

at org.eclipse.jetty.server.handler.HandlerWrapper.handle (HandlerWrapper. java:97)
at org.eclipse.jetty.server.Server.handle (Server. java:497)

at org.eclipse.jetty.server.HttpChannel.handle (HttpChannel. java:310)

at org.eclipse.jetty.server.HttpConnection.onFillable (HttpConnection. java:257)

at org.eclipse.jetty.io.AbstractConnection$2.run (AbstractConnection. java:540)

at org.eclipse.jetty.util.thread.QueuedThreadPool.runJob (QueuedThreadPool. java:635

at org.eclipse.jetty.util.thread.QueuedThreadPool$3.run (QueuedThreadPool. java:555)
at java.lang.Thread.run (Thread. java:745)

at org.springframework.remoting.support.RemoteInvocationUtils.fillInClientStackTra
celfPossible (RemoteInvocationUtils. java:45)

at org.springframework.remoting.support.RemoteInvocationResult.recreate (RemotelInvo
cationResult. java:149)

at org.springframework.remoting.support.RemoteInvocationBasedAccessor.recreateRemo
teInvocationResult (RemoteInvocationBasedAccessor. java:85)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (Ht
tpInvokerClientInterceptor. java:150)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective
MethodInvocation. java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.

java:208)

at com.sun.proxy.S$Proxy27.merge (Unknown Source)

at eu.etaxonomy.taxeditor.editor.TaxonEditorInput.merge (TaxonEditorInput. java:461)

at eu.etaxonomy.taxeditor.editor.MultiPageTaxonEditor.doSave (MultiPageTaxonEditor.
java:150)

at org.eclipse.ui.internal.SaveableHelper$2.run (SaveableHelper. java:151)

at org.eclipse.ui.internal.SaveableHelper$5.run(SaveableHelper. java:277)

at org.eclipse.jface.operation.ModalContext.runInCurrentThread (ModalContext. java:4
64)

at org.eclipse.jface.operation.ModalContext.run (ModalContext. java:372)
at org.eclipse.jface.window.ApplicationWindow$1l.run (ApplicationWindow. java:759)

at org.eclipse.swt.custom.BusyIndicator.showWhile (BusyIndicator. java:70)
ui.

ui.

ui.

ui.

ui

ui.

ui.

ui

i .internal
.internal

internal
.WorkbenchWindow. run (WorkbenchWindow. java:2649)

SaveableHelper.runProgressMonitorOperation (SaveableHelp

SaveableHelper.runProgressMonitorOperation (SaveableHelp

SaveableHelper.savePart (SaveableHelper. java:156)

EditorManager.savePart (EditorManager. java:1399)

.WorkbenchPage.savePart (WorkbenchPage. java:3416)

.WorkbenchPage.saveEditor (WorkbenchPage. java:3429)

handlers.SaveHandler.execute (SaveHandler. java:54)

.handlers.HandlerProxy.execute (HandlerProxy. java:293)

core.commands.Command.executeWithChecks (Command. java:476)

core.commands.ParameterizedCommand.executeWithChecks (ParameterizedC

ui.

ui.

ui

ui

ui

swt.

swt.

swt.

swt

ui.

ui.

ui

ui.

internal

internal

widgets

.widgets.

internal

internal

.internal

internal

widgets.

widgets.

.handlers.HandlerService.executeCommand (HandlerService.j

.handlers.SlaveHandlerService.executeCommand (SlaveHandle

.menus.CommandContributionItem.handleWidgetSelection (CommandContr

.menus.CommandContributionItem.access$19 (CommandContributionItem.

.menus.CommandContributionItem$5.handleEvent (CommandContributionI

EventTable.sendEvent (EventTable. java:84)
.Widget.sendEvent (Widget. java:1053)
Display.runDeferredEvents (Display.java:4165)
Display.readAndDispatch (Display. java:3754)
.Workbench.runEventLoop (Workbench. java:2701)
.Workbench.runUI (Workbench. java:2665)
.Workbench.access$4 (Workbench. java:2499)

.Workbench$7.run (Workbench. java:679)

core.databinding.observable.Realm.runWithDefault (Realm. java:332)

ui.internal.Workbench.createAndRunWorkbench (Workbench. java:668)

ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:149)

eu.etaxonomy.taxeditor.Application.start (Application. java:24)

org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196
at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (Ecl

ipseAppLauncher.java:110)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppla

uncher. java:79)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:344)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:179)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (Unknown Source)

at java.lang.reflect.Method.invoke (Unknown Source)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:622)

at org.eclipse.equinox.launcher.Main.basicRun (Main. java:577)

at org.eclipse.equinox.launcher.Main.run (Main.java:1410)

Caused by: org.hibernate.exception.ConstraintViolationException: could not execute statement

at org.hibernate.

ypeDelegate. java:59)

at org.hibernate.

SQLExceptionConverter. java:42)

at org.hibernate.

a:109)

at org.hibernate.

a:95)

at org.hibernate.

eturnImpl.java:207)

at org.hibernate.

gBatch.java:45)

at org.hibernate
sister.java:2886)

at org.hibernate
sister.java:3386)

at org.hibernate.

a:89)

at org.hibernate.

at org.hibernate.

at org.hibernate.
stractFlushingEventListener. java:

at org.hibernate.

tListener. java:39)

at org.hibernate.
engine.spi.ActionQueue.executeActions (ActionQueue. java:560)

engine.spi.ActionQueue.executeActions (ActionQueue. java:434)

event.internal.AbstractFlushingEventListener.performExecutions (Ab
337)

event.internal.DefaultFlushEventListener.onFlush (DefaultFlushEven

internal.SessionImpl.flush(SessionImpl. java:1282)
at org.hibernate.internal.SessionImpl.managedFlush (SessionImpl. java:465)

at org.hibernate.internal.SessionImpl.flushBeforeTransactionCompletion (SessionImpl
.java:2963)

at org.hibernate.internal.SessionImpl.beforeTransactionCompletion (SessionImpl. java
:2339)

at org.hibernate.engine. jdbc.internal.JdbcCoordinatorImpl.beforeTransactionComplet
ion (JdbcCoordinatorImpl. java:485)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelLocalTrans
actionCoordinatorImpl.beforeCompletionCallback (JdbcResourcelocalTransactionCoordinatorImpl. java:14

7)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelLocalTrans
actionCoordinatorImpl.access$100 (JdbcResourceLocalTransactionCoordinatorImpl. java:38)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelLocalTrans
actionCoordinatorImplS$TransactionDriverControlImpl.commit (JdbcResourcelLocalTransactionCoordinatorI

mpl.java:231)

at org.hibernate.engine.transaction.internal.TransactionImpl.commit (TransactionImp
1.java:65)

at org.springframework.orm.hibernate5.HibernateTransactionManager.doCommit (Hiberna
teTransactionManager. java:581)

144 more

Caused by: com.mysqgl. jdbc.exceptions. jdbc4.MySQLIntegrityConstraintViolationException: Duplicate e
ntry '997bb27e-9290-4854-be7d-9c4c370188f2"' for key 'UK_Db8inp8ckel89cpod7euwnlbgf’

at sun.reflect.NativeConstructorAccessorImpl.newInstance0 (Native Method)

at sun.reflect.NativeConstructorAccessorImpl.newInstance (NativeConstructorAccessor
Impl. java:62)

at sun.reflect.DelegatingConstructorAccessorImpl.newlnstance (DelegatingConstructor
AccessorImpl. java:45)

at java.lang.reflect.Constructor.newInstance (Constructor.java:423)

at com.mysqgl. jdbc.Util.handleNewInstance (Util.java:404)

at com.mysqgl. jdbc.Util.getInstance (Util. java:387)

at com.mysqgl. jdbc.SQLError.createSQLException (SQLError. java: 932)

at com.mysqgl.jdbc.MysglIO.checkErrorPacket (MysglIO. java:3878)

at com.mysqgl. jdbc.MysqglIO.checkErrorPacket (MysqlIO. java:3814)

at com.mysqgl. jdbc.MysglIO.sendCommand (MysglIO. java:2478)

at com.mysqgl.jdbc.MysqglIO.sglQueryDirect (MysglIO. java:2625)

at com.mysqgl. jdbc.ConnectionImpl.execSQL (ConnectionImpl. java:2551)

at com.mysqgl. jdbc.PreparedStatement.executelInternal (PreparedStatement. java:1861)

at com.mysqgl. jdbc.PreparedStatement .executeUpdatelInternal (PreparedStatement. java:2
073)

at com.mysqgl.jdbc.PreparedStatement.executeUpdateInternal (PreparedStatement. java:2
009)
at com.mysqgl.jdbc.PreparedStatement.executelLargeUpdate (PreparedStatement. java:5094

at com.mysqgl. jdbc.PreparedStatement .executeUpdate (PreparedStatement. java:1994)

at com.mchange.v2.c3p0.impl.NewProxyPreparedStatement .executeUpdate (NewProxyPrepar
edStatement. java:384)

at org.hibernate.engine. jdbc.internal.ResultSetReturnImpl.executeUpdate (ResultSetR
eturnImpl. java:204)

162 more

Associated revisions

Revision €904eb89 - 02/02/2017 01:01 PM - Katja Luther

fix #6300: the newDerivedUnitWizard should not have a session

History

#1 - 01/05/2017 02:56 PM - Andreas Miiller
- Priority changed from New to Highest

- Target version changed from Unassigned CDM tickets to Release 4.5

Maybe we can merge this ticket with a master ticket for duplicate entry issues.

#2 - 01/06/2017 11:59 AM - Katja Luther

das war wohl etwas zu kurz:

Ich habe bei der Type Designation nach der Specimen Suche und ,New" im Formular ,General Specimen Data“ nach 6ffnen des Schloss-Icons in
den Title Cache ein Typuszitat aus der Literatur (nur Text) geschrieben — also kein atomisiertes Specimen. Dann Finish. Dann OK. Dann Taxon Save.
Danach kam es zu dem genannten Fehler, den ich aber gerade in der letzten Version der Salvador Datenbank nicht reproduzieren konnte.

Herzlichen Gruf3

Walter

#3 - 01/19/2017 01:32 PM - Andreas Miiller

- Target version changed from Release 4.5 to Release 4.6

#5 - 02/02/2017 01:06 PM - Katja Luther
- Status changed from New to Resolved

- Assignee changed from Katja Luther to Patrick Plitzner

| removed the bindNullSession call and now it works. Please have a look, if everything else works, too. (I tested creation of specimen in specimen
view)

#6 - 02/02/2017 01:07 PM - Katja Luther
- % Done changed from 0 to 50

Applied in changeset taxeditor|e904eb89dc409f901b858e5936cbc08eef82f7fc.

#7 - 02/07/2017 05:19 PM - Patrick Plitzner
- Status changed from Resolved to Closed
- Assignee changed from Patrick Plitzner to Katja Luther

- % Done changed from 50 to 100

creating a new type specimen with only a protected title cache and saving it works fine
